<?php

// Global variable for table object
$tb_contracts = NULL;

//
// Table class for tb_contracts
//
class ctb_contracts extends cTable {
	var $cont_id;
	var $cont_num;
	var $court_id;
	var $cont_date;
	var $cont_project;
	var $cont_company;
	var $cont_price;
	var $cont_budjet;
	var $cont_comment;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'tb_contracts';
		$this->TableName = 'tb_contracts';
		$this->TableType = 'TABLE';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->GridAddRowCount = 5;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row

		// cont_id
		$this->cont_id = new cField('tb_contracts', 'tb_contracts', 'x_cont_id', 'cont_id', '`cont_id`', '`cont_id`', 3, -1, FALSE, '`cont_id`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->cont_id->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['cont_id'] = &$this->cont_id;

		// cont_num
		$this->cont_num = new cField('tb_contracts', 'tb_contracts', 'x_cont_num', 'cont_num', '`cont_num`', '`cont_num`', 200, -1, FALSE, '`cont_num`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['cont_num'] = &$this->cont_num;

		// court_id
		$this->court_id = new cField('tb_contracts', 'tb_contracts', 'x_court_id', 'court_id', '`court_id`', '`court_id`', 200, -1, FALSE, '`court_id`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['court_id'] = &$this->court_id;

		// cont_date
		$this->cont_date = new cField('tb_contracts', 'tb_contracts', 'x_cont_date', 'cont_date', '`cont_date`', 'DATE_FORMAT(`cont_date`, \'%Y/%m/%d %H:%i:%s\')', 133, 5, FALSE, '`cont_date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->cont_date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['cont_date'] = &$this->cont_date;

		// cont_project
		$this->cont_project = new cField('tb_contracts', 'tb_contracts', 'x_cont_project', 'cont_project', '`cont_project`', '`cont_project`', 200, -1, FALSE, '`cont_project`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['cont_project'] = &$this->cont_project;

		// cont_company
		$this->cont_company = new cField('tb_contracts', 'tb_contracts', 'x_cont_company', 'cont_company', '`cont_company`', '`cont_company`', 200, -1, FALSE, '`cont_company`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['cont_company'] = &$this->cont_company;

		// cont_price
		$this->cont_price = new cField('tb_contracts', 'tb_contracts', 'x_cont_price', 'cont_price', '`cont_price`', '`cont_price`', 131, -1, FALSE, '`cont_price`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->cont_price->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['cont_price'] = &$this->cont_price;

		// cont_budjet
		$this->cont_budjet = new cField('tb_contracts', 'tb_contracts', 'x_cont_budjet', 'cont_budjet', '`cont_budjet`', '`cont_budjet`', 131, -1, FALSE, '`cont_budjet`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->cont_budjet->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['cont_budjet'] = &$this->cont_budjet;

		// cont_comment
		$this->cont_comment = new cField('tb_contracts', 'tb_contracts', 'x_cont_comment', 'cont_comment', '`cont_comment`', '`cont_comment`', 200, -1, FALSE, '`cont_comment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['cont_comment'] = &$this->cont_comment;
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	function SqlFrom() { // From
		return "`tb_contracts`";
	}

	function SqlSelect() { // Select
		return "SELECT * FROM " . $this->SqlFrom();
	}

	function SqlWhere() { // Where
		$sWhere = "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlGroupBy() { // Group By
		return "";
	}

	function SqlHaving() { // Having
		return "";
	}

	function SqlOrderBy() { // Order By
		return "";
	}

	// Check if Anonymous User is allowed
	function AllowAnonymousUser() {
		switch (@$this->PageID) {
			case "add":
			case "register":
			case "addopt":
				return FALSE;
			case "edit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return FALSE;
			case "delete":
				return FALSE;
			case "view":
				return FALSE;
			case "search":
				return FALSE;
			default:
				return FALSE;
		}
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		return TRUE;
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->SqlSelect(), $this->SqlWhere(),
			$this->SqlGroupBy(), $this->SqlHaving(), $this->SqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->SqlSelect(), $this->SqlWhere(),
			$this->SqlGroupBy(), $this->SqlHaving(), $this->SqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->SqlSelect(), $this->SqlWhere(), $this->SqlGroupBy(),
			$this->SqlHaving(), $this->SqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->SqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		global $conn;
		$cnt = -1;
		if ($this->TableType == 'TABLE' || $this->TableType == 'VIEW') {
			$sSql = "SELECT COUNT(*) FROM" . substr($sSql, 13);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		global $conn;
		$origFilter = $this->CurrentFilter;
		$this->Recordset_Selecting($this->CurrentFilter);
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Update Table
	var $UpdateTable = "`tb_contracts`";

	// INSERT statement
	function InsertSQL(&$rs) {
		global $conn;
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]))
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		global $conn;
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "") {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]))
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = $this->CurrentFilter;
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "") {
		global $conn;
		return $conn->Execute($this->UpdateSQL($rs, $where));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "") {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if ($rs) {
			$sql .= ew_QuotedName('cont_id') . '=' . ew_QuotedValue($rs['cont_id'], $this->cont_id->FldDataType) . ' AND ';
		}
		if (substr($sql, -5) == " AND ") $sql = substr($sql, 0, -5);
		$filter = $this->CurrentFilter;
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " AND " . $filter;
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "") {
		global $conn;
		return $conn->Execute($this->DeleteSQL($rs, $where));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`cont_id` = @cont_id@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->cont_id->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@cont_id@", ew_AdjustSql($this->cont_id->CurrentValue), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "tb_contractslist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "tb_contractslist.php";
	}

	// View URL
	function GetViewUrl() {
		return $this->KeyUrl("tb_contractsview.php", $this->UrlParm());
	}

	// Add URL
	function GetAddUrl() {
		return "tb_contractsadd.php";
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		return $this->KeyUrl("tb_contractsedit.php", $this->UrlParm($parm));
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		return $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		return $this->KeyUrl("tb_contractsadd.php", $this->UrlParm($parm));
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		return $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("tb_contractsdelete.php", $this->UrlParm());
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->cont_id->CurrentValue)) {
			$sUrl .= "cont_id=" . urlencode($this->cont_id->CurrentValue);
		} else {
			return "javascript:alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET)) {
			$arKeys[] = @$_GET["cont_id"]; // cont_id

			//return $arKeys; // do not return yet, so the values will also be checked by the following code
		}

		// check keys
		$ar = array();
		foreach ($arKeys as $key) {
			if (!is_numeric($key))
				continue;
			$ar[] = $key;
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->cont_id->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {
		global $conn;

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->cont_id->setDbValue($rs->fields('cont_id'));
		$this->cont_num->setDbValue($rs->fields('cont_num'));
		$this->court_id->setDbValue($rs->fields('court_id'));
		$this->cont_date->setDbValue($rs->fields('cont_date'));
		$this->cont_project->setDbValue($rs->fields('cont_project'));
		$this->cont_company->setDbValue($rs->fields('cont_company'));
		$this->cont_price->setDbValue($rs->fields('cont_price'));
		$this->cont_budjet->setDbValue($rs->fields('cont_budjet'));
		$this->cont_comment->setDbValue($rs->fields('cont_comment'));
	}

	// Render list row values
	function RenderListRow() {
		global $conn, $Security;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// cont_id
		// cont_num
		// court_id
		// cont_date
		// cont_project
		// cont_company
		// cont_price
		// cont_budjet
		// cont_comment
		// cont_id

		$this->cont_id->ViewValue = $this->cont_id->CurrentValue;
		$this->cont_id->ViewCustomAttributes = "";

		// cont_num
		$this->cont_num->ViewValue = $this->cont_num->CurrentValue;
		$this->cont_num->ViewCustomAttributes = "";

		// court_id
		$this->court_id->ViewValue = $this->court_id->CurrentValue;
		$this->court_id->ViewCustomAttributes = "";

		// cont_date
		$this->cont_date->ViewValue = $this->cont_date->CurrentValue;
		$this->cont_date->ViewValue = ew_FormatDateTime($this->cont_date->ViewValue, 5);
		$this->cont_date->ViewCustomAttributes = "";

		// cont_project
		$this->cont_project->ViewValue = $this->cont_project->CurrentValue;
		$this->cont_project->ViewCustomAttributes = "";

		// cont_company
		$this->cont_company->ViewValue = $this->cont_company->CurrentValue;
		$this->cont_company->ViewCustomAttributes = "";

		// cont_price
		$this->cont_price->ViewValue = $this->cont_price->CurrentValue;
		$this->cont_price->ViewCustomAttributes = "";

		// cont_budjet
		$this->cont_budjet->ViewValue = $this->cont_budjet->CurrentValue;
		$this->cont_budjet->ViewCustomAttributes = "";

		// cont_comment
		$this->cont_comment->ViewValue = $this->cont_comment->CurrentValue;
		$this->cont_comment->ViewCustomAttributes = "";

		// cont_id
		$this->cont_id->LinkCustomAttributes = "";
		$this->cont_id->HrefValue = "";
		$this->cont_id->TooltipValue = "";

		// cont_num
		$this->cont_num->LinkCustomAttributes = "";
		$this->cont_num->HrefValue = "";
		$this->cont_num->TooltipValue = "";

		// court_id
		$this->court_id->LinkCustomAttributes = "";
		$this->court_id->HrefValue = "";
		$this->court_id->TooltipValue = "";

		// cont_date
		$this->cont_date->LinkCustomAttributes = "";
		$this->cont_date->HrefValue = "";
		$this->cont_date->TooltipValue = "";

		// cont_project
		$this->cont_project->LinkCustomAttributes = "";
		$this->cont_project->HrefValue = "";
		$this->cont_project->TooltipValue = "";

		// cont_company
		$this->cont_company->LinkCustomAttributes = "";
		$this->cont_company->HrefValue = "";
		$this->cont_company->TooltipValue = "";

		// cont_price
		$this->cont_price->LinkCustomAttributes = "";
		$this->cont_price->HrefValue = "";
		$this->cont_price->TooltipValue = "";

		// cont_budjet
		$this->cont_budjet->LinkCustomAttributes = "";
		$this->cont_budjet->HrefValue = "";
		$this->cont_budjet->TooltipValue = "";

		// cont_comment
		$this->cont_comment->LinkCustomAttributes = "";
		$this->cont_comment->HrefValue = "";
		$this->cont_comment->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {
	}

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;

		// Write header
		$Doc->ExportTableHeader();
		if ($Doc->Horizontal) { // Horizontal format, write header
			$Doc->BeginExportRow();
			if ($ExportPageType == "view") {
				$Doc->ExportCaption($this->cont_id);
				$Doc->ExportCaption($this->cont_num);
				$Doc->ExportCaption($this->court_id);
				$Doc->ExportCaption($this->cont_date);
				$Doc->ExportCaption($this->cont_project);
				$Doc->ExportCaption($this->cont_company);
				$Doc->ExportCaption($this->cont_price);
				$Doc->ExportCaption($this->cont_budjet);
				$Doc->ExportCaption($this->cont_comment);
			} else {
				$Doc->ExportCaption($this->cont_id);
				$Doc->ExportCaption($this->cont_num);
				$Doc->ExportCaption($this->court_id);
				$Doc->ExportCaption($this->cont_date);
				$Doc->ExportCaption($this->cont_project);
				$Doc->ExportCaption($this->cont_company);
				$Doc->ExportCaption($this->cont_price);
				$Doc->ExportCaption($this->cont_budjet);
				$Doc->ExportCaption($this->cont_comment);
			}
			$Doc->EndExportRow();
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
				if ($ExportPageType == "view") {
					$Doc->ExportField($this->cont_id);
					$Doc->ExportField($this->cont_num);
					$Doc->ExportField($this->court_id);
					$Doc->ExportField($this->cont_date);
					$Doc->ExportField($this->cont_project);
					$Doc->ExportField($this->cont_company);
					$Doc->ExportField($this->cont_price);
					$Doc->ExportField($this->cont_budjet);
					$Doc->ExportField($this->cont_comment);
				} else {
					$Doc->ExportField($this->cont_id);
					$Doc->ExportField($this->cont_num);
					$Doc->ExportField($this->court_id);
					$Doc->ExportField($this->cont_date);
					$Doc->ExportField($this->cont_project);
					$Doc->ExportField($this->cont_company);
					$Doc->ExportField($this->cont_price);
					$Doc->ExportField($this->cont_budjet);
					$Doc->ExportField($this->cont_comment);
				}
				$Doc->EndExportRow();
			}
			$Recordset->MoveNext();
		}
		$Doc->ExportTableFooter();
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
