<?php

// Global variable for table object
$tb_nb_people = NULL;

//
// Table class for tb_nb_people
//
class ctb_nb_people extends cTable {
	var $per_id;
	var $court_id;
	var $per_fname;
	var $per_lname;
	var $per_position_type;
	var $per_position;
	var $per_status;
	var $per_status_date;
	var $per_detail;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'tb_nb_people';
		$this->TableName = 'tb_nb_people';
		$this->TableType = 'TABLE';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->GridAddRowCount = 5;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row

		// per_id
		$this->per_id = new cField('tb_nb_people', 'tb_nb_people', 'x_per_id', 'per_id', '`per_id`', '`per_id`', 200, -1, FALSE, '`per_id`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['per_id'] = &$this->per_id;

		// court_id
		$this->court_id = new cField('tb_nb_people', 'tb_nb_people', 'x_court_id', 'court_id', '`court_id`', '`court_id`', 200, -1, FALSE, '`court_id`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['court_id'] = &$this->court_id;

		// per_fname
		$this->per_fname = new cField('tb_nb_people', 'tb_nb_people', 'x_per_fname', 'per_fname', '`per_fname`', '`per_fname`', 200, -1, FALSE, '`per_fname`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['per_fname'] = &$this->per_fname;

		// per_lname
		$this->per_lname = new cField('tb_nb_people', 'tb_nb_people', 'x_per_lname', 'per_lname', '`per_lname`', '`per_lname`', 200, -1, FALSE, '`per_lname`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['per_lname'] = &$this->per_lname;

		// per_position_type
		$this->per_position_type = new cField('tb_nb_people', 'tb_nb_people', 'x_per_position_type', 'per_position_type', '`per_position_type`', '`per_position_type`', 3, -1, FALSE, '`per_position_type`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->per_position_type->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['per_position_type'] = &$this->per_position_type;

		// per_position
		$this->per_position = new cField('tb_nb_people', 'tb_nb_people', 'x_per_position', 'per_position', '`per_position`', '`per_position`', 200, -1, FALSE, '`per_position`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['per_position'] = &$this->per_position;

		// per_status
		$this->per_status = new cField('tb_nb_people', 'tb_nb_people', 'x_per_status', 'per_status', '`per_status`', '`per_status`', 3, -1, FALSE, '`per_status`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->per_status->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['per_status'] = &$this->per_status;

		// per_status_date
		$this->per_status_date = new cField('tb_nb_people', 'tb_nb_people', 'x_per_status_date', 'per_status_date', '`per_status_date`', 'DATE_FORMAT(`per_status_date`, \'%Y/%m/%d %H:%i:%s\')', 133, 5, FALSE, '`per_status_date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->per_status_date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['per_status_date'] = &$this->per_status_date;

		// per_detail
		$this->per_detail = new cField('tb_nb_people', 'tb_nb_people', 'x_per_detail', 'per_detail', '`per_detail`', '`per_detail`', 200, -1, FALSE, '`per_detail`', FALSE, FALSE, FALSE, 'FORMATTED TEXT');
		$this->fields['per_detail'] = &$this->per_detail;
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	function SqlFrom() { // From
		return "`tb_nb_people`";
	}

	function SqlSelect() { // Select
		return "SELECT * FROM " . $this->SqlFrom();
	}

	function SqlWhere() { // Where
		$sWhere = "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlGroupBy() { // Group By
		return "";
	}

	function SqlHaving() { // Having
		return "";
	}

	function SqlOrderBy() { // Order By
		return "";
	}

	// Check if Anonymous User is allowed
	function AllowAnonymousUser() {
		switch (@$this->PageID) {
			case "add":
			case "register":
			case "addopt":
				return FALSE;
			case "edit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return FALSE;
			case "delete":
				return FALSE;
			case "view":
				return FALSE;
			case "search":
				return FALSE;
			default:
				return FALSE;
		}
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		return TRUE;
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->SqlSelect(), $this->SqlWhere(),
			$this->SqlGroupBy(), $this->SqlHaving(), $this->SqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->SqlSelect(), $this->SqlWhere(),
			$this->SqlGroupBy(), $this->SqlHaving(), $this->SqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->SqlSelect(), $this->SqlWhere(), $this->SqlGroupBy(),
			$this->SqlHaving(), $this->SqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->SqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		global $conn;
		$cnt = -1;
		if ($this->TableType == 'TABLE' || $this->TableType == 'VIEW') {
			$sSql = "SELECT COUNT(*) FROM" . substr($sSql, 13);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		global $conn;
		$origFilter = $this->CurrentFilter;
		$this->Recordset_Selecting($this->CurrentFilter);
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Update Table
	var $UpdateTable = "`tb_nb_people`";

	// INSERT statement
	function InsertSQL(&$rs) {
		global $conn;
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]))
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		global $conn;
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "") {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]))
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = $this->CurrentFilter;
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "") {
		global $conn;
		return $conn->Execute($this->UpdateSQL($rs, $where));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "") {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if ($rs) {
			$sql .= ew_QuotedName('per_id') . '=' . ew_QuotedValue($rs['per_id'], $this->per_id->FldDataType) . ' AND ';
		}
		if (substr($sql, -5) == " AND ") $sql = substr($sql, 0, -5);
		$filter = $this->CurrentFilter;
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " AND " . $filter;
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "") {
		global $conn;
		return $conn->Execute($this->DeleteSQL($rs, $where));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`per_id` = '@per_id@'";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		$sKeyFilter = str_replace("@per_id@", ew_AdjustSql($this->per_id->CurrentValue), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "tb_nb_peoplelist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "tb_nb_peoplelist.php";
	}

	// View URL
	function GetViewUrl() {
		return $this->KeyUrl("tb_nb_peopleview.php", $this->UrlParm());
	}

	// Add URL
	function GetAddUrl() {
		return "tb_nb_peopleadd.php";
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		return $this->KeyUrl("tb_nb_peopleedit.php", $this->UrlParm($parm));
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		return $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		return $this->KeyUrl("tb_nb_peopleadd.php", $this->UrlParm($parm));
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		return $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("tb_nb_peopledelete.php", $this->UrlParm());
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->per_id->CurrentValue)) {
			$sUrl .= "per_id=" . urlencode($this->per_id->CurrentValue);
		} else {
			return "javascript:alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET)) {
			$arKeys[] = @$_GET["per_id"]; // per_id

			//return $arKeys; // do not return yet, so the values will also be checked by the following code
		}

		// check keys
		$ar = array();
		foreach ($arKeys as $key) {
			$ar[] = $key;
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->per_id->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {
		global $conn;

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->per_id->setDbValue($rs->fields('per_id'));
		$this->court_id->setDbValue($rs->fields('court_id'));
		$this->per_fname->setDbValue($rs->fields('per_fname'));
		$this->per_lname->setDbValue($rs->fields('per_lname'));
		$this->per_position_type->setDbValue($rs->fields('per_position_type'));
		$this->per_position->setDbValue($rs->fields('per_position'));
		$this->per_status->setDbValue($rs->fields('per_status'));
		$this->per_status_date->setDbValue($rs->fields('per_status_date'));
		$this->per_detail->setDbValue($rs->fields('per_detail'));
	}

	// Render list row values
	function RenderListRow() {
		global $conn, $Security;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// per_id
		// court_id
		// per_fname
		// per_lname
		// per_position_type
		// per_position
		// per_status
		// per_status_date
		// per_detail
		// per_id

		$this->per_id->ViewValue = $this->per_id->CurrentValue;
		$this->per_id->ViewCustomAttributes = "";

		// court_id
		$this->court_id->ViewValue = $this->court_id->CurrentValue;
		$this->court_id->ViewCustomAttributes = "";

		// per_fname
		$this->per_fname->ViewValue = $this->per_fname->CurrentValue;
		$this->per_fname->ViewCustomAttributes = "";

		// per_lname
		$this->per_lname->ViewValue = $this->per_lname->CurrentValue;
		$this->per_lname->ViewCustomAttributes = "";

		// per_position_type
		if (strval($this->per_position_type->CurrentValue) <> "") {
			switch ($this->per_position_type->CurrentValue) {
				case $this->per_position_type->FldTagValue(1):
					$this->per_position_type->ViewValue = $this->per_position_type->FldTagCaption(1) <> "" ? $this->per_position_type->FldTagCaption(1) : $this->per_position_type->CurrentValue;
					break;
				case $this->per_position_type->FldTagValue(2):
					$this->per_position_type->ViewValue = $this->per_position_type->FldTagCaption(2) <> "" ? $this->per_position_type->FldTagCaption(2) : $this->per_position_type->CurrentValue;
					break;
				case $this->per_position_type->FldTagValue(3):
					$this->per_position_type->ViewValue = $this->per_position_type->FldTagCaption(3) <> "" ? $this->per_position_type->FldTagCaption(3) : $this->per_position_type->CurrentValue;
					break;
				case $this->per_position_type->FldTagValue(4):
					$this->per_position_type->ViewValue = $this->per_position_type->FldTagCaption(4) <> "" ? $this->per_position_type->FldTagCaption(4) : $this->per_position_type->CurrentValue;
					break;
				case $this->per_position_type->FldTagValue(5):
					$this->per_position_type->ViewValue = $this->per_position_type->FldTagCaption(5) <> "" ? $this->per_position_type->FldTagCaption(5) : $this->per_position_type->CurrentValue;
					break;
				case $this->per_position_type->FldTagValue(6):
					$this->per_position_type->ViewValue = $this->per_position_type->FldTagCaption(6) <> "" ? $this->per_position_type->FldTagCaption(6) : $this->per_position_type->CurrentValue;
					break;
				default:
					$this->per_position_type->ViewValue = $this->per_position_type->CurrentValue;
			}
		} else {
			$this->per_position_type->ViewValue = NULL;
		}
		$this->per_position_type->ViewCustomAttributes = "";

		// per_position
		$this->per_position->ViewValue = $this->per_position->CurrentValue;
		$this->per_position->ViewCustomAttributes = "";

		// per_status
		if (strval($this->per_status->CurrentValue) <> "") {
			switch ($this->per_status->CurrentValue) {
				case $this->per_status->FldTagValue(1):
					$this->per_status->ViewValue = $this->per_status->FldTagCaption(1) <> "" ? $this->per_status->FldTagCaption(1) : $this->per_status->CurrentValue;
					break;
				case $this->per_status->FldTagValue(2):
					$this->per_status->ViewValue = $this->per_status->FldTagCaption(2) <> "" ? $this->per_status->FldTagCaption(2) : $this->per_status->CurrentValue;
					break;
				case $this->per_status->FldTagValue(3):
					$this->per_status->ViewValue = $this->per_status->FldTagCaption(3) <> "" ? $this->per_status->FldTagCaption(3) : $this->per_status->CurrentValue;
					break;
				case $this->per_status->FldTagValue(4):
					$this->per_status->ViewValue = $this->per_status->FldTagCaption(4) <> "" ? $this->per_status->FldTagCaption(4) : $this->per_status->CurrentValue;
					break;
				case $this->per_status->FldTagValue(5):
					$this->per_status->ViewValue = $this->per_status->FldTagCaption(5) <> "" ? $this->per_status->FldTagCaption(5) : $this->per_status->CurrentValue;
					break;
				case $this->per_status->FldTagValue(6):
					$this->per_status->ViewValue = $this->per_status->FldTagCaption(6) <> "" ? $this->per_status->FldTagCaption(6) : $this->per_status->CurrentValue;
					break;
				default:
					$this->per_status->ViewValue = $this->per_status->CurrentValue;
			}
		} else {
			$this->per_status->ViewValue = NULL;
		}
		$this->per_status->ViewCustomAttributes = "";

		// per_status_date
		$this->per_status_date->ViewValue = $this->per_status_date->CurrentValue;
		$this->per_status_date->ViewValue = ew_FormatDateTime($this->per_status_date->ViewValue, 5);
		$this->per_status_date->ViewCustomAttributes = "";

		// per_detail
		$this->per_detail->ViewValue = $this->per_detail->CurrentValue;
		$this->per_detail->ViewCustomAttributes = "";

		// per_id
		$this->per_id->LinkCustomAttributes = "";
		$this->per_id->HrefValue = "";
		$this->per_id->TooltipValue = "";

		// court_id
		$this->court_id->LinkCustomAttributes = "";
		$this->court_id->HrefValue = "";
		$this->court_id->TooltipValue = "";

		// per_fname
		$this->per_fname->LinkCustomAttributes = "";
		$this->per_fname->HrefValue = "";
		$this->per_fname->TooltipValue = "";

		// per_lname
		$this->per_lname->LinkCustomAttributes = "";
		$this->per_lname->HrefValue = "";
		$this->per_lname->TooltipValue = "";

		// per_position_type
		$this->per_position_type->LinkCustomAttributes = "";
		$this->per_position_type->HrefValue = "";
		$this->per_position_type->TooltipValue = "";

		// per_position
		$this->per_position->LinkCustomAttributes = "";
		$this->per_position->HrefValue = "";
		$this->per_position->TooltipValue = "";

		// per_status
		$this->per_status->LinkCustomAttributes = "";
		$this->per_status->HrefValue = "";
		$this->per_status->TooltipValue = "";

		// per_status_date
		$this->per_status_date->LinkCustomAttributes = "";
		$this->per_status_date->HrefValue = "";
		$this->per_status_date->TooltipValue = "";

		// per_detail
		$this->per_detail->LinkCustomAttributes = "";
		$this->per_detail->HrefValue = "";
		$this->per_detail->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {
	}

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;

		// Write header
		$Doc->ExportTableHeader();
		if ($Doc->Horizontal) { // Horizontal format, write header
			$Doc->BeginExportRow();
			if ($ExportPageType == "view") {
				$Doc->ExportCaption($this->per_id);
				$Doc->ExportCaption($this->court_id);
				$Doc->ExportCaption($this->per_fname);
				$Doc->ExportCaption($this->per_lname);
				$Doc->ExportCaption($this->per_position_type);
				$Doc->ExportCaption($this->per_position);
				$Doc->ExportCaption($this->per_status);
				$Doc->ExportCaption($this->per_status_date);
				$Doc->ExportCaption($this->per_detail);
			} else {
				$Doc->ExportCaption($this->per_id);
				$Doc->ExportCaption($this->court_id);
				$Doc->ExportCaption($this->per_fname);
				$Doc->ExportCaption($this->per_lname);
				$Doc->ExportCaption($this->per_position_type);
				$Doc->ExportCaption($this->per_position);
				$Doc->ExportCaption($this->per_status);
				$Doc->ExportCaption($this->per_status_date);
				$Doc->ExportCaption($this->per_detail);
			}
			$Doc->EndExportRow();
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
				if ($ExportPageType == "view") {
					$Doc->ExportField($this->per_id);
					$Doc->ExportField($this->court_id);
					$Doc->ExportField($this->per_fname);
					$Doc->ExportField($this->per_lname);
					$Doc->ExportField($this->per_position_type);
					$Doc->ExportField($this->per_position);
					$Doc->ExportField($this->per_status);
					$Doc->ExportField($this->per_status_date);
					$Doc->ExportField($this->per_detail);
				} else {
					$Doc->ExportField($this->per_id);
					$Doc->ExportField($this->court_id);
					$Doc->ExportField($this->per_fname);
					$Doc->ExportField($this->per_lname);
					$Doc->ExportField($this->per_position_type);
					$Doc->ExportField($this->per_position);
					$Doc->ExportField($this->per_status);
					$Doc->ExportField($this->per_status_date);
					$Doc->ExportField($this->per_detail);
				}
				$Doc->EndExportRow();
			}
			$Recordset->MoveNext();
		}
		$Doc->ExportTableFooter();
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
